/* This program will help clean up duplicate files from a
   hard disk with many subdirectories.
   Written by Harvey Miller 6-27-86
   */
#include "stdio.h"
#include "ctype.h"
#include "utility.h"
#define ROOT "\\"
#define TRUE  1
#define FALSE 0
#define  lobyte(a)    (a & 0x00ff)
#define  hibyte(a)    ((a >> 8) & 0x00ff)
#define  byword(a,b)  ((a << 8) | (b & 0x00ff))
#define  max(a,b)     ((a)>(b)?(a):(b))
#define  min(a,b)     ((a)<=(b)?(a):(b))
/* the following defines set up the size of various structures */
#define  FILSIZE 18   /* size of struct files */
#define  SUBSIZE 64   /* size of struct subdir */
#define  BASESIZE 20  /* size of the fixed portion of struct duplicates */
/* the following defines set up the BDOS function constants */
#define  CHDIR 0x3B   /* Change directories */
#define  SETDTA 0x1A  /* Set DTA address  */
#define  GETFIRST 0x4E /* Get first file match */
#define  GETNEXT  0x4F /* Get next file match  */
#define  GETCURR  0x47 /* Get current subdirectory */
#define  BDOSDEL  0x41 /* Delete file function */
#define  BDOSREN  0x56 /* Rename file function */
#define  OPENFILE 0x3D /* Open file */
#define  CLOSFILE 0x3E /* Close file */
#define  READFILE 0x3F /* Read file */
#define  GETXERR  0x59 /* Get Extended Error */
#define  CHMOD    0x43 /* Change File Mode */
struct subdir {
    char dirname[64];
    };
struct files {
    char name[14];
    struct subdir *subdir;
    struct files *next;
    };
struct files *filetop;
struct subdir *subtop;
main(argc,argv)
int argc;
char argv[];
{
    char subdir[64];
    struct files *calloc();
    get_current(subdir);
    if (argc==1) {
        welcome();
        filetop=calloc(FILSIZE,1);
        filetop->name[0]='\0';
        subtop=calloc(SUBSIZE,1);
        strcpy(subtop->dirname,ROOT);
        /* start in root directory */
        bdos(CHDIR,ROOT);
        gotoxy(12,20);
        printf("directory: %s\n",ROOT);
        gotoxy(26,1);
        /* read all subdirectories and fill in linked list of files */
        getfiles(subtop);
        /* display all duplicate files and handle user interface */
        display();
        /* return to original subdirectory */
        bdos(CHDIR,subdir);
        clrscr();
    }
}
welcome()
{
    clrscr();
    gotoxy(2,20);
    printf("The Tree Surgeon Version 1.00\n");
    gotoxy(10,20);
    printf("Reading Directories\n");
    gotoxy(23,5);
    printf("(C) Copyright 1986 Harvey W. Miller.");
    printf("  All rights reserved.\n");
    }
print_head()
{
/* routine to clear screen and put normal messages on screen */
    clrscr();
    gotoxy(0,30);
    printf("Duplicate Files\n");
/*  gotoxy(23,5);
    printf("Use cursor keys to move to a specific file\n"); */
    gotoxy(1,1);
}
getfiles(subpnt) struct subdir *subpnt;
/* this routine reads the directory entries and for file entries it
   will add the file to the linked list of files.  For directory
   entries it will call itself recursively to get all file entries
   for subdirectories */
{
    char DTABuffer[43];
    int done;
    struct subdir *subnew;
    /* set DTA address */
    bdos(SETDTA,DTABuffer);
    done=getfirst();
    /* if entry is not directory entry, add file to linked list */
    if (DTABuffer[21]!=0x10) {
        addfile(DTABuffer,subpnt);
    }
    else {
        /* this is a new subdirectory ('.' is this subdirectory)  */
        if (DTABuffer[30]!='.') {
             /* change to new directory */
             bdos(CHDIR,&DTABuffer[30]);
             gotoxy(12,20);
             clreol();
             printf("directory: %s\n",&DTABuffer[30]);
             gotoxy(26,1);
             /* set up new subdirectory control block */
             subnew=calloc(SUBSIZE,1);
             strcpy(subnew->dirname,subpnt->dirname);
             if (strcmp(subnew->dirname,ROOT))
                strcat(subnew->dirname,ROOT);
             strcat(subnew->dirname,&DTABuffer[30]);
             /* recursively call getfiles for new subdirectory */
             getfiles(subnew);
             /* now go back to original subdirectory (".." means
                parent subdirectory), and set up correct DTA address
                again */
             bdos(CHDIR,"..");
             bdos(SETDTA,DTABuffer);
        }
    }
    done=getnext();
    while (!done) {
        if (DTABuffer[21]!=0x10) {
            addfile(DTABuffer,subpnt);
        }
        else {
            /* this is a new subdirectory ('.' is this subdirectory)  */
            if (DTABuffer[30]!='.') {
                 /* change to new directory */
                 bdos(CHDIR,&DTABuffer[30]);
                 gotoxy(12,20);
                 clreol();
                 printf("directory: %s\n",&DTABuffer[30]);
                 /* set up new subdirectory control block */
                 subnew=calloc(SUBSIZE,1);
                 strcpy(subnew->dirname,subpnt->dirname);
                 if (strcmp(subnew->dirname,ROOT))
                 strcat(subnew->dirname,ROOT);
                 strcat(subnew->dirname,&DTABuffer[30]);
                 /* recursively call getfiles for new subdirectory */
                 getfiles(subnew);
                 /* now go back to original subdirectory (".." means
                    parent subdirectory), and set up correct DTA address
                    again */
                 bdos(CHDIR,"..");
                 bdos(SETDTA,DTABuffer);
            }
        }
        done=getnext();
    }
    return(done);
}
addfile(DTABuffer,subpnt) char *DTABuffer; struct subdir *subpnt;
{
/* this routine chains a new file entry onto our linked list in
   alphebetical order using an insertion sort (slow, but it works) */
    int i,done;
    char filename[14];
    struct files *newfile,*lastfile,*chkfile,*calloc();
    /* build up file name from the DTA buffer */
    for (i=30;i<43;i++) {
        filename[i-30]=DTABuffer[i];
    }
    lastfile=filetop;
    newfile=calloc(FILSIZE,1);
    strcpy(newfile->name,filename);
    newfile->subdir=subpnt;
    done=FALSE;
    /* now look for proper placement in linked list */
    for (chkfile=filetop;!done;chkfile=chkfile->next) {
        if ((strcmp(chkfile->name,newfile->name) > 0||(!chkfile))) {
            lastfile->next=newfile;
            newfile->next=chkfile;
            done=TRUE;
        }
        else lastfile=chkfile;
    }
}
display()
{
/* this is the display module.  At this point, the files linked list
   has been built and points to the appropriate subdir block. */
#define UP '-'
#define DOWN '+'
#define PGUP 'U'
#define PGDN 'P'
#define VIEW 'V'
#define ATTR 'A'
#define DELETE 'D'
#define CMPR 'C'
#define RENAME 'R'
#define FILEPOS 5
#define SUBDPOS 8
#define FRSTLINE 2
#define LASTLINE 20
    int linenum,cnt,cnt1;
    char answer[80],c;
    struct files *i,*j,*last;
    struct subdir *subpnt;
    struct duplicates {
        char fname[14];
        int  dupcnt;
        struct duplicates *back;
        struct duplicates *next;
        struct subdir *sub[255];
    };
    struct scrstr {
        struct duplicates *fpnt;
        int subnum;
    };
    struct duplicates *lastdup,*current,*duptop;
    struct scrstr screen[24];
    int lastline,curline,col;
    last=0;
    lastdup=0;
    linenum=0;
    print_head();
    last=filetop;
    /* look through all files for duplicates */
    for (i=filetop->next;i;i=i->next) {
        if (strcmp(i->name,last->name)==0) {
            j=i->next;cnt=2;
            /* duplicates found, are there more? */
            while (strcmp(i->name,j->name)==0) {
                j=j->next;
                cnt++;
            }
            /* allocate enough memory for all duplicates */
            current=calloc(BASESIZE+2*cnt,1);
            strcpy(current->fname,i->name);
            current->dupcnt=cnt;
            current->back=lastdup;
            current->next=0;
            if (lastdup!=0) lastdup->next=current;
            else duptop=current;
            i=last;
            for (cnt=0;cnt<current->dupcnt;cnt++) {
                current->sub[cnt]=i->subdir;
                i=i->next;
            }
            lastdup=current;
        }
        last=i;
    }
    /* now duplicates has been built and display can begin */
    lastline=scrout(FRSTLINE,LASTLINE,duptop,screen);
    curline=FRSTLINE;
    curset(curline,screen[curline].subnum);
    current=duptop;
    while ((c=scrin())!='Q') {
        switch (c) {
        case UP:
            /* up arrow pressed...back up one entry */
            if (--curline>FRSTLINE) {
                /* go back to previous entry on screen */
                if (screen[curline].subnum==0) col=FILEPOS;
                else col=SUBDPOS;
                curset(curline,screen[curline].subnum);
            }
            else {
                /* at top of page...must scroll back to previous
                   file entry */
                if (current->back!=0) current=current->back;
                lastline=scrout(FRSTLINE,LASTLINE,current,screen);
                curline=FRSTLINE;
                curset(curline,screen[curline].subnum);
            }
            break;
        case DOWN:
            /* down arrow pressed */
            if (curline++<lastline) {
                /* move cursor down to next entry */
                if (screen[curline].subnum==0) col=FILEPOS;
                else col=SUBDPOS;
                curset(curline,screen[curline].subnum);
            }
            else {
                /* at bottom of page..must scroll down one file entry */
                if (current->next!=0) {
                    curline=curline-current->dupcnt-1;
                    current=current->next;
                }
                lastline=scrout(FRSTLINE,LASTLINE,current,screen);
                if (curline>lastline)
                    curline=FRSTLINE;
                curset(curline,screen[curline].subnum);
            }
            break;
        case PGUP:
            /* PgUp pressed...scroll up one page */
            cnt=1;
            curline=FRSTLINE;
            while (cnt<LASTLINE) {
                if (current->back!=0) {
                    current=current->back;
                    cnt += current->dupcnt+1;
                }
                else {
                    cnt=LASTLINE;
                }
            }
            if (cnt>LASTLINE) current=current->next;
            lastline=scrout(FRSTLINE,LASTLINE,current,screen);
            curset(curline,screen[curline].subnum);
            break;
        case PGDN:
            /* PgDn pressed...scroll down one page */
            cnt=1;
            curline=FRSTLINE;
            while (cnt<lastline) {
                cnt += current->dupcnt+1;
                if (current->next!=0) current=current->next;
            }
            lastline=scrout(FRSTLINE,LASTLINE,current,screen);
            curset(curline,screen[curline].subnum);
            break;
        case VIEW:
            /* request to view file...only valid for subdir entry */
            cnt=screen[curline].subnum;
            if (cnt) {
                clrscr();
                printf("Viewing file %s from directory %s\n",
                    screen[curline].fpnt->fname,
                    (screen[curline].fpnt)->sub[cnt-1]->dirname);
                lastline=scrout(FRSTLINE,LASTLINE,current,screen);
                curset(curline,screen[curline].subnum);
            }
            break;
        case ATTR:
            /* request to show file attributes...only valid for
               file entries (not subdirs) */
            cnt=screen[curline].subnum;
            if (!cnt) {
                current=screen[curline].fpnt;
                for (cnt=0;cnt<current->dupcnt;cnt++) {
                    gotoxy(curline+cnt+1,40);
                    attrshow(current->fname,current->sub[cnt]);
                }
                curset(curline,screen[curline].subnum);
            }
            break;
        case DELETE:
            /* request to delete file from subdir...only valid from
               subdir entry */
            cnt=screen[curline].subnum;
            if (cnt) {
                gotoxy(1,1);
                printf("Confirm delete of file %s in directory %s\n",
                    screen[curline].fpnt->fname,
                    (screen[curline].fpnt)->sub[cnt-1]->dirname);
                if ((c=scrin())=='Y') {
                    cnt1=delete(screen[curline].fpnt->fname,
                    (screen[curline].fpnt)->sub[cnt-1]->dirname);
                    if (cnt1) {
                        current=screen[curline].fpnt;
                        current->dupcnt--;
                        for (cnt1=cnt;cnt1<=current->dupcnt;cnt1++) {
                            current->sub[cnt1-1]=current->sub[cnt1];
                        }
                        lastline=scrout(FRSTLINE,LASTLINE,current,screen);
                        curline=FRSTLINE;
                    }
                }
                gotoxy(1,0);
                clreol();
                curset(curline,screen[curline].subnum);
            }
            break;
        case RENAME:
            /* request to rename file from subdir...only valid from
               subdir entry */
            cnt=screen[curline].subnum;
            if (cnt) {
                gotoxy(1,1);
                printf("Enter new filename for file %s in directory %s\n",
                    screen[curline].fpnt->fname,
                    (screen[curline].fpnt)->sub[cnt-1]->dirname);
                gotoxy(curline,40);
                scanf("%s",&answer);
                cnt1=rename(screen[curline].fpnt->fname,
                    (screen[curline].fpnt)->sub[cnt-1]->dirname,answer);
                if (cnt1) {
                    current=screen[curline].fpnt;
                    current->dupcnt--;
                    for (cnt1=cnt;cnt1<=current->dupcnt;cnt1++) {
                        current->sub[cnt1-1]=current->sub[cnt1];
                    }
                    lastline=scrout(FRSTLINE,LASTLINE,current,screen);
                    curline=FRSTLINE;
                }
                gotoxy(1,0);
                clreol();
                curset(curline,screen[curline].subnum);
            }
            break;
        case CMPR:
            /* request to compare file in all subdirs...only valid
               on file entry */
            cnt=screen[curline].subnum;
            if (!cnt) {
                current=screen[curline].fpnt;
                clrscr();
                for (cnt=0;cnt<current->dupcnt-1;cnt++) {
                    for (cnt1=cnt+1;cnt1<current->dupcnt;cnt1++) {
                        compare(current->fname,current->sub[cnt],
                            current->sub[cnt1]);
                    }
                }
                gotoxy(23,1);
                printf("Press any key to continue\n");
                scrin();
                print_head();
                lastline=scrout(FRSTLINE,LASTLINE,current,screen);
                curline=FRSTLINE;
                curset(curline,screen[curline].subnum);
            }
            break;
        }
    }
}
scrout(start,end,topstruct,scrstruct)
    int start,end;
    struct duplicates *topstruct;
    struct scrstr scrstruct[];
{
/* this routine will output one screen full of data.  It will also
   fill in the scrstruct array for easy access to the data on screen,
   and it will return the last line actually written. */
    struct duplicates {
        char fname[14];
        int  dupcnt;
        struct duplicates *back;
        struct duplicates *next;
        struct subdir *sub[255];
    };
    struct scrstr {
        struct duplicates *fpnt;
        int subnum;
    };
    struct duplicates *current;
    int linenum,cnt,linecnt;
    scroll(20,7,FRSTLINE,0,22,79,0);
    for (linenum=start,current=topstruct;linenum<end && current;
        linenum++,current=current->next) {
        if (linenum+current->dupcnt<=end) {
            gotoxy(linenum,FILEPOS);
            printf("%s\n",current->fname);
            scrstruct[linenum].subnum=0;
            scrstruct[linenum].fpnt=current;
            for (cnt=0;cnt<current->dupcnt;cnt++) {
                gotoxy(++linenum,SUBDPOS);
                printf("%s\n",(current->sub[cnt])->dirname);
                scrstruct[linenum].subnum=cnt+1;
                scrstruct[linenum].fpnt=current;
                linecnt=linenum;
            }
        }
        else linenum=end;
    }
    return(linecnt);
}
scrin()
{
/* this routine will wait for one character to be entered from the
   keyboard and return it in a more useful form.  It will translate
   the extended scan codes to a single value which can be more
   easily dealt with in the main program. */
    int c;
    if ((c=getch())==0) {
        /* this is an extended character.  The next read will determine
           what the key pressed really is. */
        c=getch();
        switch (c) {
        case 72:
            /* up arrow */
            c='-';
            break;
        case 80:
            /* down arrow */
            c='+';
            break;
        case 73:
            /* PgUp */
            c='U';
            break;
        case 81:
            /* PgDn */
            c='P';
            break;
        default:
            /* unknown...don't let it be confused with regular chars */
            c=0;
        }
    }
    return(toupper(c));
}
curset(line,subflag) int line,subflag;
{
    if (subflag) {
        gotoxy(23,5);
        printf("Commands: Quit, Delete, Rename, PgUp, PgDn");
        clreol();
        printf(", \30, \31\n");
        gotoxy(line,SUBDPOS);
    }
    else {
        gotoxy(23,5);
        printf("Commands: Quit, Attribute, Compare, PgUp, PgDn");
        clreol();
        printf(", \30, \31\n");
        gotoxy(line,FILEPOS);
    }
}
attrshow(file,subdir) char *file,*subdir;
{
/* this routine will display the attributes of the file.  This includes
   date & time of last update, file size, and special attributes */
    union data {
        char DTABuffer[43];
        unsigned int values[21];
    } DTA;
    extern unsigned _cxreg;
    char attrstr[5],strtime[12],ampm[3];
    float size;
    int hh,mm,ss,dd,mon,yy,i;
    char pathname[77];
    bdos(SETDTA,DTA.DTABuffer);
    /* set up full pathname for BDOS call */
    strcpy(pathname,subdir);
    if (strcmp(subdir,ROOT))
        strcat(pathname,ROOT);
    strcat(pathname,file);
    _cxreg=0x37;
    xbdos(GETFIRST,pathname);
    hh=DTA.values[11]>>11;
    mm=DTA.values[11]<<5>>10;
    ss=DTA.values[11]&0x1F;
    dd=DTA.values[12]&0x1F;
    mon=(DTA.values[12]&0x1E0)>>5;
    yy=DTA.values[12]>>9;
    attrstr[0]='\0';
    if ((DTA.DTABuffer[21]&1)==1) strcat(attrstr,"R");
    if ((DTA.DTABuffer[21]&2)==2) strcat(attrstr,"H");
    if ((DTA.DTABuffer[21]&4)==4) strcat(attrstr,"S");
    if ((DTA.DTABuffer[21]&32)==32) strcat(attrstr,"A");
    if (hh>11) {
        hh=hh-12;
        strcpy(ampm,"pm");
    }
    else strcpy(ampm,"am");
    if (hh==0) hh=12;
    sprintf(strtime,"%2d:%2d:%2d%s",hh,mm,ss,ampm);
    for (i=0;i<8;i++) if (strtime[i]==' ') strtime[i]='0';
    size=DTA.values[13] + DTA.values[14] * 64 * 1024;
    printf("%5s %2d/%2d/%2d %8s %10.0f\n",attrstr,mon,dd,yy+80,
        strtime,size);
}
delete(file,subdir) char *file,*subdir;
{
/* this routine will delete a file from the specified subdirectory */
    union data {
        char DTABuffer[43];
        unsigned int values[21];
    } DTA;
    char pathname[77];
    extern unsigned _axreg,_bxreg,_cxreg,_dxreg,_sireg,_direg;
    unsigned errflag;
    /* first build the full path name being carefull of files in
       the root directory (avoid "\\filename") */
    strcpy(pathname,subdir);
    if (strcmp(subdir,ROOT)) strcat(pathname,ROOT);
    strcat(pathname,file);
    bdos(SETDTA,DTA.DTABuffer);
    _cxreg=0x37;
    xbdos(GETFIRST,pathname);
    if (DTA.DTABuffer[21]&1==1) {
        gotoxy(1,1);
        clreol();
        printf("This file is marked Read Only.  Delete OK? (Y/N)\n");
        if (scrin()!='Y') return(FALSE);
        _cxreg=DTA.DTABuffer[21]&0xFE;
        _axreg=1;
        errflag=xbdos(CHMOD,pathname);
    }
    errflag = bdos(BDOSDEL,pathname) & 1;
    return(!errflag);
}
rename(file,subdir,newpath) char *file,*subdir,*newpath;
{
/* this routine will rename a file from the specified subdirectory */
    char pathname[77];
    char newpname[77];
    extern unsigned _axreg,_bxreg,_cxreg,_dxreg,_sireg,_direg;
    unsigned errflag;
    int i,done;
    /* first build the full path name being carefull of files in
       the root directory (avoid "\\filename") */
    strcpy(pathname,subdir);
    if (strcmp(subdir,ROOT)) strcat(pathname,ROOT);
    strcat(pathname,file);
    /* now build the new path name.  If the input path name has a
       subdirectory, leave it alone.  Otherwise add current subdir
       to beginning of name. */
    for (i=0,done=FALSE;newpath[i],!done;i++) {
        if (newpath[i]==ROOT) {
            strcpy(newpname,newpath);
            done=TRUE;
        }
    }
    if (!done) {
        strcpy(newpname,subdir);
        if (strcmp(subdir,ROOT)) strcat(pathname,ROOT);
        strcat(newpname,newpath);
    }
    _direg=&newpname[0];
    errflag = xbdos(BDOSREN,pathname) & 1;
    return(!errflag);
}
compare(file,subdir1,subdir2) char *file,*subdir1,*subdir2;
{
/* compare the file from the two specified subdirectories */
#define BUFSIZE 128
    union data {
        char DTABuffer[43];
        unsigned int values[21];
    } DTA;
    float size1,size2;
    char path1[77],path2[77],buff1[BUFSIZE],buff2[BUFSIZE];
    int equal,eof,numread1,numread2,fcnt;
    FILE *f1,*f2;
    /* build up both full path names */
    strcpy(path1,subdir1);
    strcpy(path2,subdir2);
    if (strcmp(path1,ROOT)) strcat(path1,ROOT);
    if (strcmp(path2,ROOT)) strcat(path2,ROOT);
    strcat(path1,file);
    strcat(path2,file);
    printf("Comparing files %s and %s\n",path1,path2);
    bdos(SETDTA,DTA.DTABuffer);
    _cxreg=0x37;
    xbdos(GETFIRST,path1);
    size1=DTA.values[13]+DTA.values[14]*64*1024;
    xbdos(GETFIRST,path2);
    size2=DTA.values[13]+DTA.values[14]*64*1024;
    /* only read the files if both sizes are the same */
    if (size1==size2) {
        printf("Comparing %.0f bytes\n",size1);
        if ((f1=xopen(path1,"r"))==NULL) {
            printf("Can't open %s\n",path1);
            return(0);
        }
        if ((f2=xopen(path2,"r"))==NULL) {
            printf("Can't open %s\n",path2);
            xclose(f1);
            return(0);
        }
        equal=TRUE;
        eof=FALSE;
        while (!eof&&equal) {
            numread1=xread(f1,buff1,BUFSIZE);
            numread2=xread(f2,buff2,BUFSIZE);
            if (numread1<BUFSIZE) eof=TRUE;
            /* compare to see if all chars read are the same */
            for (fcnt=0;fcnt<numread1 && fcnt<numread2 && equal;
            fcnt++) {
                if (buff1[fcnt]!=buff2[fcnt]) {
                    printf("Files not equal at byte %d\n",fcnt+1);
                    equal=FALSE;
                }
            }
        }
        if (equal) {
            printf("Files are identical\n");
        }
        xclose(f2);
        xclose(f1);
    }
    else printf("Size of files not equal\n");
}
/* the following routines are the BDOS interface routines */
get_current(subdir) char *subdir;
{
/* this routine will get the current subdirectory.  Notice that
   BDOS call 47 (get current directory) returns the directory
   without the beginning '\'.  XBDOS call was used to gain access
   is the si register. */
    extern unsigned _axreg,_bxreg,_cxreg,_dxreg,_sireg,_direg;
    char loc_subdir[64];
    _sireg = subdir;
    xbdos(GETCURR,0);
    if (strcmp(subdir,ROOT)!=0) {
        strcpy(loc_subdir,ROOT);
        strcat(loc_subdir,subdir);
        strcpy(subdir,loc_subdir);
    }
    return(0);
}
xopen(file,mode) char *file, *mode;
{
/* this routine is used to open a file from any legal path.  It is
   used instead of the normal open because LATTICE C will only
   open files from the current subdirectory.  This is obviously
   insufficient for the task. */
    extern unsigned _axreg,_bxreg,_cxreg,_dxreg,_sireg,_direg;
    unsigned errflag;
    _axreg = 0;
    errflag = xbdos(OPENFILE,file) & 1;
    if (errflag) {
        printf("error from xopen is %x\n",_axreg);
        return(NULL);
    }
    return(_axreg);
}
xread(handle,buffer,bufsize) int handle,bufsize; char *buffer;
{
/* this routine is used to read one buffer from a file opened via
   xopen. */
    extern unsigned _axreg,_bxreg,_cxreg,_dxreg,_sireg,_direg;
    unsigned errflag;
    _bxreg = handle;
    _cxreg = bufsize;
    errflag = xbdos(READFILE,buffer) & 1;
    if (errflag) return(-1);
    return(_axreg);
}
xclose(handle) int handle;
{
/* this routine will close a file opened via xopen. */
    extern unsigned _axreg,_bxreg,_cxreg,_dxreg,_sireg,_direg;
    unsigned errflag;
    _bxreg = handle;
    errflag = xbdos(CLOSFILE,0) & 1;
    return(_axreg);
}
getfirst()
{
/* BDOS interface to get the first matching file.  XBDOS call is
   used because normal BDOS call does not allow passing of registers
   other than AH and DS.  Also notice that the file mask is
   "????????.???".  That will return all files.  This could be changed
   to only return files matching a certain pattern, but it would
   require extra processing to get all subdirectory entries. */
    extern unsigned _cxreg,_dxreg,_axreg;
    _cxreg=0x37;
    xbdos(GETFIRST,"????????.???");
    return(lobyte(_axreg));
}
getnext()
{
    return(bdos(GETNEXT,"????????.???"));
}
/* the following routines are general routines dealing with the
   video display. */
int clreol()
{
/* this routine will clear the screen from the cursor position to
   the end of the line */
    struct regval{unsigned ax,bx,cx,dx,si,di,ds,es;};
    struct regval input_regs,
                  return_regs;
    int x,y;
    /* first find out where the cursor is */
    getxy(&x,&y);
    input_regs.ax = byword(07,0); /* set to scroll down entire window */
    input_regs.bx = byword(07,0); /* use 07 attribute */
    input_regs.cx = byword(y,x);  /* upper left */
    input_regs.dx = byword(y,79); /* lower right */
    /* now scroll using video interrupt from BIOS */
    swint(16,&input_regs,&return_regs);
    return(0);
}
int getxy(column,row) int *row,*column;
{
/* this routine determines the current cursor postion */
        struct regval{unsigned ax,bx,cx,dx,si,di,ds,es;};
        struct regval input_regs,
                      return_regs;
    input_regs.ax = byword(03,00); /* set for read cursor position */
    input_regs.bx = 0;             /* bx is page number */
    swint(16,&input_regs,&return_regs);
    /* now put returned values where they belong */
    *row = hibyte(return_regs.dx);
    *column = lobyte(return_regs.dx);
    return(0);
}
int scroll(numlines,attr,row1,column1,row2,column2,direct)
int numlines,attr,row1,column1,row2,column2,direct;
{
/* this routine will scroll the screen numlines using attribute attr
   in a window from row1,column1 to row2,column2.  Direct can be
   0 or 1.  0 for scroll up and 1 for scroll down. */
    struct regval{unsigned ax,bx,cx,dx,si,di,ds,es;};
    struct regval input_regs,
                  return_regs;
    row1 = max(0,min(row1,24));
    row2 = max(row1,min(row2,24));
    column1 = max(0,min(column1,79));
    column2 = max(column1,min(column2,79));
    input_regs.ax = byword(06+direct,numlines);
    input_regs.bx = byword(attr,0);
    input_regs.cx = byword(row1,column1);
    input_regs.dx = byword(row2,column2);
    swint(16,&input_regs,&return_regs);
    /* now set cursor position to top of window */
    input_regs.ax = byword(02,00);
    input_regs.dx = byword(row1,column1);
    input_regs.bx = 0;
    swint(16,&input_regs,&return_regs);
    return(0);
}
int clrscr()
{
    struct regval{unsigned ax,bx,cx,dx,si,di,ds,es;};
    struct regval input_regs,
                  return_regs;
    input_regs.ax = byword(07,0);
    input_regs.bx = byword(07,0);
    input_regs.cx = byword(00,00);
    input_regs.dx = byword(24,79);
    swint(16,&input_regs,&return_regs);
    input_regs.ax = byword(02,00);
    input_regs.dx = 0;
    input_regs.bx = 0;
    swint(16,&input_regs,&return_regs);
    return(0);
}
int gotoxy(row,column) int row,column;
{
        struct regval{unsigned ax,bx,cx,dx,si,di,ds,es;};
        struct regval input_regs,
                      return_regs;
    input_regs.ax = byword(02,00);
    if (row>24) row = 24;
    if (row<0) row = 0;
    if (column>79) column = 79;
    if (column<0) column = 0;
    input_regs.dx = byword(row,column);
    input_regs.bx = 0;
    swint(16,&input_regs,&return_regs);
    return(0);
}
